package com.datacloudsec.scan.service.impl;

import com.datacloudsec.exception.UEException;
import com.datacloudsec.scan.common.Constant;
import com.datacloudsec.scan.dao.PenetestMapper;
import com.datacloudsec.scan.service.IPenetest;
import com.datacloudsec.utils.InstanceUtil;
import com.datacloudsec.utils.ObjectUtil;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;

/* loaded from: com_datacloudsec_scan_service_impl.jar:com/datacloudsec/scan/service/impl/PenetestService.class */
public class PenetestService implements IPenetest {
    private PenetestMapper penetestMapper = (PenetestMapper) InstanceUtil.newDaoInstance(PenetestMapper.class);
    private static final Logger LOG = Logger.getLogger(PenetestService.class);

    public void insertPeneCmd(Integer uid, String url, String cmd, String cmd2, String cmd3, String fileName, String type, String results, String headers, String method, String body, Integer impFlag, String cmd4) throws Exception {
        this.penetestMapper.insertPeneCmd(uid, url, cmd, cmd2, cmd3, fileName, type, results, headers, method, body, impFlag, cmd4);
    }

    public Map<String, Object> getPeneCmdByUid(Integer uid, String type) throws Exception {
        return this.penetestMapper.getPeneCmdByUid(uid, type);
    }

    public void delPeneByUidAndType(Integer uid, String type) throws Exception {
        this.penetestMapper.delPeneByUidAndType(uid, type);
    }

    public void updPeneCmd(Integer uid, String type, String results) {
        this.penetestMapper.updPeneCmd(uid, type, results);
    }

    /* JADX WARN: Type inference failed for: r0v71, types: [com.datacloudsec.scan.service.impl.PenetestService$1] */
    public void startattack(HttpServletRequest req, Integer type) throws Exception {
        final HttpSession session = req.getSession();
        final String key = String.valueOf(session.getId()) + "attack";
        session.removeAttribute(key);
        session.removeAttribute(String.valueOf(key) + "error");
        session.removeAttribute(String.valueOf(key) + "finish");
        List<String> cmdList = new ArrayList<>();
        if (System.getProperty("os.name").toLowerCase().contains("window")) {
            cmdList.add("cmd");
            cmdList.add("/c");
            cmdList.add("ping -t www.baidu.com");
        } else {
            cmdList.add("sh");
            cmdList.add(new File(Constant.WORK_DIR, "tools/nettest.sh").getAbsolutePath());
            cmdList.add(new StringBuilder().append(type).toString());
            if (type.intValue() == 6) {
                cmdList.add(req.getParameter("ip"));
            } else if (type.intValue() == 7 || type.intValue() == 8 || type.intValue() == 9) {
                cmdList.add(req.getParameter("port"));
                cmdList.add(req.getParameter("ip"));
            } else if (type.intValue() == 14) {
                cmdList.add(req.getParameter("ip"));
                cmdList.add(req.getParameter("port"));
            } else if (type.intValue() == 17 || type.intValue() == 18) {
                cmdList.add(req.getParameter("ip"));
            } else if (type.intValue() == 19) {
                cmdList.add(req.getParameter("ip"));
                cmdList.add(req.getParameter("destip"));
            } else if (type.intValue() == 20) {
                cmdList.add(req.getParameter("inter"));
                cmdList.add(req.getParameter("destip"));
                cmdList.add(req.getParameter("gw"));
            } else if (type.intValue() == 21) {
                cmdList.add(req.getParameter("ip"));
            } else {
                throw new UEException("参数错误");
            }
        }
        LOG.debug("执行命令：" + StringUtils.join(cmdList, ","));
        ProcessBuilder pb = new ProcessBuilder(cmdList);
        pb.redirectErrorStream(true);
        final Process process = pb.start();
        session.setAttribute(String.valueOf(key) + "process", process);
        new Thread() { // from class: com.datacloudsec.scan.service.impl.PenetestService.1
            @Override // java.lang.Thread, java.lang.Runnable
            public void run() {
                BufferedReader br = null;
                InputStreamReader isr = null;
                InputStream is = null;
                try {
                    try {
                        try {
                            session.setAttribute(key, "开始运行");
                            is = process.getInputStream();
                            isr = new InputStreamReader(is, Charset.defaultCharset().toString());
                            br = new BufferedReader(isr);
                            while (true) {
                                String line = br.readLine();
                                if (line == null) {
                                    break;
                                } else {
                                    session.setAttribute(key, String.valueOf(ObjectUtil.getString(session.getAttribute(key), "")) + "\r\n" + line);
                                }
                            }
                            session.setAttribute(String.valueOf(key) + "finish", true);
                            session.removeAttribute(String.valueOf(key) + "process");
                            IOUtils.closeQuietly(br);
                            IOUtils.closeQuietly(isr);
                            IOUtils.closeQuietly(is);
                            if (process != null) {
                                process.destroy();
                            }
                        } catch (Exception e) {
                            session.setAttribute(String.valueOf(key) + "error", "读取运行结果出错");
                            PenetestService.LOG.error("命令运行出错", e);
                            session.setAttribute(String.valueOf(key) + "finish", true);
                            session.removeAttribute(String.valueOf(key) + "process");
                            IOUtils.closeQuietly(br);
                            IOUtils.closeQuietly(isr);
                            IOUtils.closeQuietly(is);
                            if (process != null) {
                                process.destroy();
                            }
                        }
                    } catch (IOException e2) {
                        PenetestService.LOG.debug("强制结束时可能会出错，属于正常现象", e2);
                        session.setAttribute(String.valueOf(key) + "finish", true);
                        session.removeAttribute(String.valueOf(key) + "process");
                        IOUtils.closeQuietly(br);
                        IOUtils.closeQuietly(isr);
                        IOUtils.closeQuietly(is);
                        if (process != null) {
                            process.destroy();
                        }
                    }
                } catch (Throwable th) {
                    session.setAttribute(String.valueOf(key) + "finish", true);
                    session.removeAttribute(String.valueOf(key) + "process");
                    IOUtils.closeQuietly(br);
                    IOUtils.closeQuietly(isr);
                    IOUtils.closeQuietly(is);
                    if (process != null) {
                        process.destroy();
                    }
                    throw th;
                }
            }
        }.start();
    }

    public void stopattack(HttpServletRequest req) throws Exception {
        HttpSession session = req.getSession();
        String key = String.valueOf(session.getId()) + "attack";
        session.setAttribute(key, String.valueOf(ObjectUtil.getString(session.getAttribute(key), "")) + "\r\n开始停止");
        Process process = (Process) session.getAttribute(String.valueOf(key) + "process");
        if (process != null) {
            process.destroy();
            IOUtils.closeQuietly(process.getInputStream());
            IOUtils.closeQuietly(process.getOutputStream());
            session.removeAttribute(String.valueOf(key) + "process");
        }
    }
}
